<?php 
/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @since             1.0.2
 * @package           GCHelp
 *
 * @wordpress-plugin
 * Plugin Name:       GC Help
 * Description:       Treinamentos, dicas e insights sobre SEO, redes sociais, conteúdo e tudo o que é necessário para um blog de sucesso.
 * Version:           1.0.2
 * Author:            gCampaner
 * Author URI:        http://gcampaner.com.br/
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       gc-help
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}


/**
 * The code that runs during plugin activation.
 * This action is documented in includes/gchelp-activator.php
 */
function activate_GCHelp() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/gchelp-activator.php';
	GCHelp_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/gchelp-deactivator.php
 */
function deactivate_GCHelp() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/gchelp-deactivator.php';
	GCHelp_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_GCHelp' );
register_deactivation_hook( __FILE__, 'deactivate_GCHelp' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/gchelp.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.2
 */
function run_GCHelp() {

	$plugin = new GCHelp();
	$plugin->run();

}
run_GCHelp();