<?php

class Structure {

	private $structure;
	private $user;
	private $connect;

	#In minutes
	const CACHE_TIME = 120;

    public function __construct () {
		require_once plugin_dir_path( __FILE__ ) . 'gchelp-connect.php';
        //$this->connect = new Connect_DB();
    }


	// ****************************** CACHE  ********************************//
	/**
	 *
	 * SAVE CACHE FILE
	 *
	 * @param string $html_conteudo html content to cache
	 *
	 * @return 
	*/      
	// ***********************************************************************//
	public function cache_file( $html_conteudo, $path_file ) {
		file_put_contents( $path_file, '<!-- cached:'.time().'-->'.$html_conteudo );
	}



	// ********************* DOWNLOAD IMAGES LOCALY  ************************//
	/**
	 *
	 * DOWNLOAD IMAGES TO LOCAL SERVER
	 *
	 * @param string $image_url | string $file_name
	 *
	 * @return string "Image path url"
	*/      
	// ***********************************************************************//
	public function download_and_get_path_image($image_url, $file_name) {
		$image_temp_file = WP_CONTENT_DIR.'/cache/';
		$get_image_file  = WP_CONTENT_URL.'/cache/';

		$image = wp_remote_retrieve_body( wp_remote_get($image_url) );
		file_put_contents( $image_temp_file.$file_name, $image );

		return $get_image_file.$file_name;
	}




	// **************************** BUILD STRUCTURE **************************//
	/**
	 *
	 * RETURN THE PLUGIN HTML STRUCTURE
	 *
	 * @param boolean $premium_user false if check if user is premium
	 *
	 * @return string <html>
	*/      
	// ***********************************************************************//
	public function build_structure( $premium_user = false, $theme, $path_file ) {

		
		// if permission denied
		if ( !is_writable( WP_CONTENT_DIR.'/cache/' ) ) {
		    
			/*********************
				> ERROR - if directory doesn't exist or isn't writable.
			**********************/
		    add_action( 'admin_notices', array( $this, 'gchelp_notice_error_write' ) );

		} else {

			require_once plugin_dir_path(__DIR__) . 'includes/gchelp-restapi.php';

			$api = new GCHelp_API();
			
			// function get_posts( $postperpage = 10, $orderby = 'name', $order = 'asc', $category = null )
			$posts_insights	= $api->get_posts( 15, 'date', 'desc', 1 );
			$posts_cursos	= $api->get_posts( 15, 'date', 'desc', 2 );

			if ( ! empty( $posts_cursos ) && ! is_wp_error( $posts_cursos ) ) {

				if ( ! empty( $posts_insights ) && ! is_wp_error( $posts_insights ) ) {

					if ( $theme == 'darktech' ) {
						$tech 	  = 'is-tech';
						$tech_img = 'tech-';
						$active_t = '-active';
					} else {
						$tech 		= '';
						$tech_img 	= '';
						$active_t 	= '';
					}
					/********

						PREPARA O CONTEÚDO DE INSIGHTS

					*********/

					$conteudo_dinamico_insights = '';
					$i 							= 0;

					foreach ($posts_insights as $value) {
						$id_image 	= '';
						$image_url 	= '';
						$id_image 	= $value->featured_media;

						if ( $id_image != 0 ) {
							$object_image = $api->get_post_media( $id_image );
							if ( isset( $object_image->guid->rendered ) ) {
								$image_url = $object_image->guid->rendered;
							}
						}

						if ( $image_url == '' ) $image_url = plugins_url().'/gc-help/admin/images/gcampaner.jpg';

						$conteudo 	= $value->content->rendered;
						$titulo 	= $value->title->rendered;

				        //if ( $i != 0 ) {
						if ( true ) {

							//download_and_get_path_image($image_url, $file_name)
							$image_path = self::download_and_get_path_image($image_url, sanitize_title($titulo).'.jpg' );
				        	$conteudo_dinamico_insights .= '
				        	<div class="post post-insights" 
				        	data-title="'.$titulo.'"
				        	data-imagem="'.$image_path.'"
				        	data-conteudo="'.str_replace('"', "'", $conteudo).'">

				                <div class="imagem">
				                    <img src="'.$image_path.'" alt="">
				                </div>
				                <div class="conteudo '.$tech.'">
				                    <h2 class="main-title">'.$titulo.'</h2>
				                </div>
			                </div>';
				        } else {
				        	$conteudo_dinamico_insights .= '
				        	<div class="post post-insights post-destaque"  
				        	data-title="'.$titulo.'"
				        	data-imagem="'.$image_url.'"
				        	data-conteudo="'.str_replace('"', "'", $conteudo).'">
				                <div class="imagem">
				                    <img src="'.$image_url.'" alt="">
				                </div>
				                <div class="conteudo '.$tech.'">
				                    <h2 class="main-title">'.$titulo.'</h2>
				                    <p>'.substr( strip_tags($conteudo), 0, 150).'...</p>
				                </div>
			                </div>';
				        }

			            $i++;
					}

					/********

						PREPARA O CONTEÚDO DE CURSOS

					*********/
					$conteudo_dinamico_cursos   = '';
					$i 							= 0;

					foreach ($posts_cursos as $value) {
						$id_image 	= '';
						$image_url 	= '';
						$id_image 	= $value->featured_media;
						
						if ( $id_image != 0 ) {
							$object_image 	= $api->get_post_media( $id_image );
							$image_url 		= $object_image->media_details->sizes->medium->source_url;
						}

						if ( $image_url == '' ) $image_url = plugins_url().'/gc-help/admin/images/gcampaner.jpg';
						
						$conteudo 	= $value->content->rendered;
						$titulo 	= $value->title->rendered;

				        //if ( $i != 0 ) {
				        if ( true ) {

				        	//download_and_get_path_image($image_url, $file_name)
							$image_path = self::download_and_get_path_image($image_url, sanitize_title($titulo).'.jpg' );

				        	$conteudo_dinamico_cursos .= '
				        	<div class="post post-curso"
				        	data-title="'.$titulo.'"
				        	data-video="'.$value->urlvideo.'"
				        	data-conteudo="'.$conteudo.'">
					                <div class="imagem">
					                    <img src="'.$image_path.'" alt="">
					                </div>
					                <div class="conteudo '.$tech.'">
					                    <h2 class="main-title">'.$value->title->rendered.'</h2>
					                </div>
			                </div>';
				        } else {
				        	$conteudo_dinamico_cursos .= '
				        	<div class="post post-curso post-destaque"
				        	data-title="'.$titulo.'"
				        	data-video="'.$value->urlvideo.'"
				        	data-conteudo="'.$conteudo.'">
				                <div class="imagem">
				                    <img src="'.$image_url.'" alt="">
				                </div>
				                <div class="conteudo '.$tech.'">
				                    <h2 class="main-title">'.$value->title->rendered.'</h2>
				                   	<p>'.substr( strip_tags($value->content->rendered), 0, 150).'...</p>
				                </div>
			                </div>';
				        }

			            $i++;
					}


					/**************************************************

						BLOCO QUE VERIFICA SE HÁ POST NOVO

					**************************************************/

					//$date_last_check = $this->user['last_push_check'];
					//$date_last_post  = $this->connect->check_ultimo_post();
					
					//$date_last_post_DATE 	= new DateTime( $date_last_post );
					//$date_last_check_DATE 	= new DateTime( $date_last_check );
					//$interval 				= $date_last_check_DATE->diff($date_last_post_DATE);
					//$push_notifications 	= $api->get_push();


					/* CRIA O BOX DE PUSH NOTIFICATIONS */
					//$push_messages			= '<div class="push-box" style="display: none;"><div id="close-pushbox">x</div>';
					//	if ( $push_notifications ) {
					//		foreach ($push_notifications as $value) {
					//			$push_messages .= '<p class="bubble">'.$value->content.'</p>';
					//		}
					//	}
					//$push_messages			.= '</div>';


					//if ( $interval->days > 0 && $interval->invert == 0 ) {
						$push_notification_html = '
							<div id="logo-gc-help" class="btn-a_f transit '.$tech.'">
							</div>
						';
					//} else {
					//	$push_notification_html = '
					//		'.$push_messages.'
					//		<div id="logo-gc-help" class="btn-a_f transit '.$tech.'">
					//		</div>
					//	';
					//}
					/**************************************************

						/ BLOCO QUE VERIFICA SE HÁ POST NOVO
					
					**************************************************/

					#__Estrutura
					$html_conteudo = '';
					$html_conteudo .= '
					<div class="mini-fade-gchelp"></div>
					<div class="mini-fade-gchelp-post"></div>
					<div id="gc-help" class="transit">
						'.$push_notification_html.'
						<div id="barra-gc-help">
							<i class="icones-barra-gc-help btn-seta-gc btn-a_f transit"></i>
						</div>
					</div>
					<div id="aba-notificacao-gc-help" class="cont-aba" style="display: none;">
						<div id="topo-an-gc-help" class="topo-aba '.$tech.'">
							<div class="topo-aba-logo '.$tech.'"></div>
							<span>gCampaner Help - Wordpress</span>
							<i class="btn-fechar-tan btn-a_f"></i>
						</div>
						
						<div class="welcome-msge '.$tech.'">
							<p id="user-name-display">Olá</p>
							<p>Posso ajudar em algo?</p>
						</div>
						
						<div id="session" class="'.$tech.'">INSIGHTS</div>

						<!-- DINAMIC CONTENT -->
						<div class="dinamic-content-box '.$tech.'">
					        <div id="dinamic-insight" class="dinamic-content '.$tech.' ativado">
								'.$conteudo_dinamico_insights.'
					        </div>
					        <div id="dinamic-cursos" class="dinamic-content '.$tech.'" style="display:none">
								'.$conteudo_dinamico_cursos.'
					        </div>
					        <div id="dinamic-ferramentas" class="dinamic-content '.$tech.'" style="display:none">
								<ul class="list-ferramentas '.$tech.'">
									<li>
										<a href="https://www.fotor.com/pt/" target="_blank">
											<span><img src="'.plugins_url().'/gc-help/admin/images/fotor-i.png" /></span>
											<span>
												Fotor 
													<p>Edite imagens e faça montagens de forma fácil e prática!</p>
											</span>
										</a>
									</li>
									<li>
										<a href="https://www.pexels.com/" target="_blank">
											<span><img src="'.plugins_url().'/gc-help/admin/images/pexels-i.png" /></span>
											<span>
												Pexels
													<p>Banco de imagens gratuito com ótima curadoria.</p>
											</span>
										</a>
									</li>

									<li>
										<a href="https://analytics.google.com/analytics/web/" target="_blank">
											<span><img src="'.plugins_url().'/gc-help/admin/images/analytic-i.png" /></span>
											<span>
												Google Analytics
													<p>Seu blog em números: acessos, dados geográficos, comportamento do público.</p>
											</span>
										</a>
									</li>
									<li>
										<a href="https://mail.google.com" target="_blank">
											<span><img src="'.plugins_url().'/gc-help/admin/images/gmail-i.png" /></span>
											<span>
												Google Mail
													<p>Acesse agora o e-mail seu e-mail oficial e profissional!</p>
											</span>
										</a>
									</li>
									<li>
										<a href="https://mailchimp.com/" target="_blank">
											<span><img src="'.plugins_url().'/gc-help/admin/images/mailchimp-i.png" /></span>
											<span>
												MailChimp
													<p>Dispare e-mails e newsletters para se conectar com sua audiência.</p>
											</span>
										</a>
									</li>
									<li>
										<a href="https://trends.google.com.br/trends/" target="_blank">
											<span><img src="'.plugins_url().'/gc-help/admin/images/trends-i.png" /></span>
											<span>
												Google Trends
													<p>Pesquise pautas e palavras-chave que estão em alta.</p>
											</span>
										</a>
									</li>
								</ul>
					        </div>
					        <div id="dinamic-contato" class="dinamic-content '.$tech.'" style="display:none">
								<h2>Entre em contato e vamos te ajudar!</h2>
								<p>Horário de funcionamento - 2ª a 6ª das 9h às 18h</p>
								<p>Contato financeiro: <a href="mailto:financeiro@gcampaner.com.br">financeiro@gcampaner.com.br</a></p>
								<p>Contato geral: <a href="mailto:contato@gcampaner.com.br">contato@gcampaner.com.br</a></p>
								<br />
								<p>Telefone: (11) 3081-4666</p>
					        </div>
				        </div>
		
						<!-- FIXED CONTENT -->
				        <div class="fixed-content opcoes-content '.$tech.'">
				            <div class="box '.$tech.' box-insight box-ative" data-changecontent="insight">
				                <img src="'.plugins_url().'/gc-help/admin/images/'.$tech_img.'insight-icon'.$active_t.'.png" alt="Insight Icon">
				                <h3>Insights</h3>
				            </div>
				            <div class="box '.$tech.' box-curso" data-changecontent="cursos">
				                <img src="'.plugins_url().'/gc-help/admin/images/'.$tech_img.'cursos-icon.png" alt="Curso Icon">
				                <h3>Cursos</h3>
				            </div>
				            <div class="box '.$tech.' box-ferramenta" data-changecontent="ferramentas">
				                <img src="'.plugins_url().'/gc-help/admin/images/'.$tech_img.'ferramentas-icon.png" alt="Ferramentas Icon">
				                <h3>Ferramentas</h3>
				            </div>
				            <div class="box '.$tech.' box-contato" data-changecontent="contato">
				                <img src="'.plugins_url().'/gc-help/admin/images/'.$tech_img.'contato-icon.png" alt="Contato Icon">
				                <h3>Contato</h3>
				            </div>
				        </div>
					</div>
					<div id="modal-gchelp" class="modal-gchelp-content">
						<div id="close-modal-gchelp">X</div>
		                <div class="imagem"></div>
		                <div class="conteudo '.$tech.'">
		                    <h2></h2>
		                    <div class="texto"></div>
		                </div>
					</div>
					';
					
					$minified_html_conteudo = preg_replace(array('/<!--(.*)-->/Uis',"/[[:blank:]]+/"),array('',' '),str_replace(array("\n","\r","\t"),'',$html_conteudo));

					#CACHE
					self::cache_file( $minified_html_conteudo, $path_file );

				} // IF NOT !posts_insights
			} // IF NOT !posts_cursos
		} // IF FILE IS WRITABLE
	}

	// ***************************** INIT STRUCTURE ***************************//
	/**
	 *
	 * RETURN HTML STRUCTURE TO PREMIUM OR REGULAR USERS
	 *
	 * @return string <html>
	*/      
	// ***********************************************************************//
	public function init_structure() {

		$path_file_dark  = WP_CONTENT_DIR.'/cache/gc-help-dark.html';
		$file_time_dark  = @filemtime( $path_file_dark );

		$path_file_light = WP_CONTENT_DIR.'/cache/gc-help-light.html';
		$file_time_light = @filemtime( $path_file_light );

		$current_time  = time();
		$expire_time   = self::CACHE_TIME * 60;



		if ( !file_exists( $path_file_dark ) || $file_time_dark < ( $current_time - $expire_time ) ) {
			self::build_structure( false, 'darktech', $path_file_dark );
		}

		if ( !file_exists( $path_file_light ) || $file_time_light < ( $current_time - $expire_time ) ) {
			self::build_structure( false, 'light', $path_file_light );
		}

	}

	public function print_html() {
		$path_file_dark  = WP_CONTENT_DIR.'/cache/gc-help-dark.html';
		$path_file_light = WP_CONTENT_DIR.'/cache/gc-help-light.html';

		if ( file_exists($path_file_dark) && file_exists($path_file_light) ) {
			if ( get_option('gchelpset-select') == 'darktech' ) {
				echo file_get_contents($path_file_dark);
			} else {
				echo file_get_contents($path_file_light);
			}
		}

		// user name
		$current_user = wp_get_current_user();
		echo '<script>
				jQuery("#user-name-display").html("Olá '.$current_user->display_name.'");
			</script>';
	}

	// ***************************** NOTICES ADMIN ***************************//
	/**
	 *
	 * SHOW NOTICE IN WORDPRESS ADMIN
	 *
	 * @return string <notices>
	*/      
	// ***********************************************************************//

	public function gchelp_notice_error_write() { ?>
	    <div class="notice notice-error">
	        <p><?php _e( 'GC-Help <span class="dashicons dashicons-arrow-right-alt"></span> Erro de permissão de escrita em <i>/wp-content/cache</i>', 'sample-text-domain' ); ?></p>
	    </div>
    <?php }

	public function gchelp_notice_error_allowurlfopen() { ?>
	    <div class="notice notice-error">
	        <p><?php _e( 'GC-Help <span class="dashicons dashicons-arrow-right-alt"></span> A função allow_url_fopen de seu servidor está desativada. Contate o administrador ou ative-a para o funcionamento do plugin', 'sample-text-domain' ); ?></p>
	    </div>
	    <style>
	    	#gc-help {display: none !important;visibility: hidden !important;}
	    </style>
    <?php }
}